	; ARQUITECTURA DE COMPUTADORES II, 2014
	; TP 02: Arquitecturas Segmentadas
	;
	; Calcula los mximos valores de las secuencias Hailstone correspondientes a los primeros 100 naturales.
	;

	; Comienzo del segmento de datos
	; ---

	.data

	; Tabla donde se almacenarn los resultados.
result: .word32 0

	; -----------------

	; Comienzo del segmento de programa
	; ---

	.text
	
	; Inicializo el ndice que lleva la cuenta del nmero que estoy analizando
	daddi R5,R0,1

	; Cargo la posicin del comienzo de la tabla de resultados en R4
	daddi R4,R0,result


numloop: 
        ; Inicializo el registro R2 con el nmero natural donde comienza la secuencia. 
	dadd R2,R0,R5

	; Este nmero es tambin el mximo conocido hasta ahora, que se almacena en R3.
	dadd R3,R0,R2

	; -----------------

	; Comienzo del bucle que calcula la secuencia
hailloop: 

	; El nmero de la secuencia es un nmero par?
	andi R1,R2,1
	bnez R1,odd   ; Si es impar, saltar a "odd"

	; -----------------
	
	; Nmeros pares
even:
	; Divido el nmero por dos
	dsrl R2,R2,1

	; Salteo el cdigo que corresponde a los impares
	j anynumber

	; -----------------

	; Nmeros impares
odd:
	; Multiplico por tres y suma 1
	dsll R1,R2,1
	dadd R2,R1,R2
	daddi R2,R2,1

	; -----------------
anynumber:
	
	; Si el nmero es mayor que el mximo visto hasta ahora
	dsub R1,R3,R2      ; Almaceno la diferencia entre el nmero y el mximo en R1
	dsrl R1,R1,31      ; Dejo slo el bit de signo
	beqz R1,skipnewmax ; El mximo es mayor que el nmero de la secuencia

	dadd R3,R0,R2	   ; Reemplazo el mximo
skipnewmax:

	; Si alcanc el 1, es el final de la secuencia
	daddi R1,R2,-1
	bnez R1,hailloop

	; Almaceno el mximo en la tabla
	sw R3,0(R4)

	; Incremento el ndice de la tabla
	daddi R4,R4,4 

	; Incremento el ndice de nmeros naturales
	daddi R5,R5,1

	; Ya hice los primeros 100 naturales?
	daddi R1,R5,-101
	bnez R1,numloop      

	halt


